\ BUFFER and VARIABLE
\ The definitions below reorganise the use of RAM for ROMFORTH
\ applications which are themselves to be put in PROM.
\
\ The variable R-P points to the top of available RAM, and is decremented
\ by the amount of RAM required. The word BUFFER allocates memory from
\ this space, returning its base (low) address. Words such as VARIABLE
\ can then be defined in terms of BUFFER.
\

: Buffer        \ n -- addr ; return address of n byte buffer
  abs negate r-p +!			\ reduce buffer space
  r-p @  ;				\ return base address

: variable      \ -- ; -- addr ; replacement
  create  2 buffer ,			\ lay address of data area
  does> @  ;				\ return it

End-Up-Load
